
function [x,n] = gsteepest(f,df,d2f,xn,theta,tol)

% Iterate up to a maximum of 1000 iterations

for n=0:100
    
    x(:,n+1) = xn;
    
    % Evaluate the Gradient at the current point x
    
    gx = df(xn);
    
    % For the stopping criterion check whether the norm of the gradient is 
    % below the requested tolerance

    if norm(gx) < tol
        break
    end
    
    % Evaluate the objective function at the current point x
    
    fx = f(xn);
    
    % Evaluate the Hessian at the current point x and find the 
    % generalised descent direction
    
    B  = d2f(xn);
    s = - B\gx;
    
    % Call backtracking line search
    
    alpha = linesearch(xn,fx,gx,s,theta,f);
    
    % Calculate the next iterate in steepest descent direction
    
    xn  = xn + alpha*s;
        
end

end