
% Script to apply Newton's method to the Rosenbrock function

% Set initial guess

x0 = [-1.2;1];
%x0 = [-1.2;1.5];

% Apply generalised steepest descent algorithm

tol = 1.0e-5;

[x,n] = newton(@g_Rosen,@h_Rosen,x0,tol);

% Set exact solution

xex = [1;1];

% Visualise the solution path 

visual(@f_Rosen,x,x0,xex);

disp('Number of iterations:');
n

for i=1:n+1
    e(i) = norm(x(:,i)-xex);
end

e(2:n+1)./(e(1:n).^2)

disp('Final error:');
e(n+1)
